//----------------------------------------------------------------------//
// HTMLeLXgϊNX											//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include <wininet.h>
#include <stdio.h>
#include <algorith.h>

#include "UserFunc.h"
#include "htmconv.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
//R[h̔
// charsetԂ
//---------------------------------------------------------------------------
AnsiString get_charset(AnsiString s)
{
	AnsiString ret = EmptyStr;
 	int esc_tag = 0;
	int sz = s.Length();
	for (int i=1; i<=sz; i++) {
		unsigned char c = s[i];
		if (esc_tag==0) {
			if (c==0x1b) {
				esc_tag = 1;
			} else
			if (((c>=0x80) && (c<=0x8d)) || ((c>=0x90) && (c<=0xa0))) {
				ret = "Shift_JIS";	break;
			} else
			if (c == 0xfe) {
				ret = "EUC-JP";		break;
			}

		} else
		if (esc_tag==1) {
		// ESC
			if (c=='$') 	 esc_tag = 2;
			else if (c=='(') esc_tag = 3;
			else			 esc_tag = 0;

		} else
		if (esc_tag==2) {
		// ESC + $
			esc_tag = 0;
			if ((c=='@') || (c=='B')) {
				ret = "ISO-2022-JP";	break;
			}

		} else {
		// ESC + ( / I / J
			esc_tag = 0;
			if ((c=='B') || (c=='I') || (c=='J')) {
				ret = "ISO-2022-JP";	break;
			}
		}
	}

	//łȂEUCƉ肵čă`FbN
	if (ret.IsEmpty()) {
		int cnt = 0;
		int stt = 0;
		for (int i=1; i<=sz; i++) {
			unsigned char c = s[i];
			if (stt == 0) {
			//1oCg
				if (iscntrl(c) || ((c>=0x20) && (c<=0x7e))) {
					continue;
				} else
				if (c==0x8e) {
					stt = 1;
				} else if ((c>=0xa1) && (c<=0xfe)) {
					stt = 2;
				} else {
					cnt = -1;
					break;
				}

			} else
			if (stt==1) {
			//Ji2oCg
				if ((c>=0xa1) && (c<=0xfe)) {
					cnt++;
					stt = 0;
				} else {
					cnt = -1;
					break;
				}

			} else {
			//2oCg
				if ((c>=0xa1) && (c<=0xfe)) {
					cnt++;
					stt = 0;
				} else {
					cnt = -1;
					break;
				}
			}
		}
		if (cnt>0) ret = "EUC-JP";
	}

	return ret;
}

//---------------------------------------------------------------------------
//JIS ̕ SHIFT-JIS ɕϊ
//---------------------------------------------------------------------------
unsigned int jis_to_sjis(unsigned int c)
{
    if ((c>0x7e7e) || (c<0x2121) || ((c&0xff)>0x7e) || ((c&0xff)<0x21)) return 0;
	c += 0xa17e;
    unsigned int hc = (c >> 8) & 0xff;
    unsigned int lc = c & 0xff;
	if ((hc & 1)==0) lc -= ((lc<0xde) ? 0x5f : 0x5e);
	hc >>= 1;
	hc ^= 0xe0;
	return ((hc << 8) + lc);
}

//---------------------------------------------------------------------------
//EUC ̕ Shift-JIS ɕϊ
//---------------------------------------------------------------------------
AnsiString cv_euc_str(AnsiString s)
{
	if (s.IsEmpty()) return EmptyStr;

	int sz = s.Length();
	char *rbuf = new char[sz+1];
	unsigned int cc;
	int flag = 0;
	int p1 = 0;
	for (int p0=1; p0<=sz; p0++) {
		unsigned char c = s[p0];
		switch (flag) {
		case 0:
			if (c==0x8e) {
				//pJi
				flag = 2;
			} else
			if (c & 0x80) {
				//2oCg1oCg
				cc = (unsigned int)(c & 0x7f) << 8;
				flag = 1;
			} else
				//1oCg
				rbuf[p1++] = c;
			break;
		case 1:
			//2oCg
			cc += (c & 0x7f);
			cc = jis_to_sjis(cc);
			if (cc!=0) {
				rbuf[p1++] = (char)(cc >> 8);
				rbuf[p1++] = (char)(cc & 0xff);
			}
			flag = 0;
			break;
		case 2:
			//pJi
			rbuf[p1++] = c;
			flag = 0;
			break;
		}
	}
	rbuf[p1] = '\0';
	AnsiString rstr = rbuf;
	delete [] rbuf;
	return rstr;
}

//---------------------------------------------------------------------------
//JIS ̕ Shift-JIS ɕϊ
//---------------------------------------------------------------------------
AnsiString cv_jis_str(AnsiString s)
{
	if (s.IsEmpty()) return EmptyStr;

	int sz = s.Length();
	char *rbuf = new char[sz+1];
	unsigned int cc;
	int flag = 0;
	int p1 = 0;
	for (int p0=1; p0<=sz; p0++) {
		unsigned char c = s[p0];
		switch (flag) {
		case 0:
			if (c==0x1b)
				flag++;
			else
				//1oCg
				rbuf[p1++] = c;
			break;
		case 1:
			if (c=='$') flag++; else flag = 0;
			break;
		case 2:
			if ((c=='B') || (c=='@')) flag++; else flag = 0;
			break;
		case 3:	//1oCg
			if (c==0x1b)
				flag = 5;
			else {
				cc = (unsigned int)c << 8;
				flag++;
			}
			break;
		case 4:	//2oCg
			cc += (unsigned char)c;
			cc = jis_to_sjis(cc);
			if (cc!=0) {
				rbuf[p1++] = (char)(cc >> 8);
				rbuf[p1++] = (char)(cc & 0xff);
			}
			flag--;
			break;
		case 5:
			if (c=='(') flag++; else flag = 0;
			break;
		case 6:
			flag = 0;
			break;
		}
	}
	rbuf[p1] = '\0';
	AnsiString rstr = rbuf;
	delete [] rbuf;
	return rstr;
}

//---------------------------------------------------------------------------
//UTF-8 ̕ Shift-JIS ɕϊ
//---------------------------------------------------------------------------
AnsiString cv_utf8_str(AnsiString s)
{
	AnsiString rstr;
	char *u8buf = s.c_str();
	int n = ::MultiByteToWideChar(CP_UTF8,0, u8buf, -1, NULL, 0);
	if (n>0) {
		WCHAR *ubuf = new WCHAR[n];
		::ZeroMemory(ubuf, sizeof(WCHAR)*n);
		::MultiByteToWideChar(CP_UTF8,0, u8buf, -1, (LPWSTR)ubuf, n);
		n = ::WideCharToMultiByte(CP_ACP,0,(LPWSTR)ubuf, -1, NULL,0,NULL,NULL);
		if (n>0) {
			char *sbuf = new char[n+1];
			::WideCharToMultiByte(CP_ACP,0,(LPWSTR)ubuf, -1, sbuf,n,NULL,NULL);
			sbuf[n] = '\0';
			rstr = sbuf;
			delete [] sbuf;
		}
		delete [] ubuf;
	}
    return rstr;
}

//---------------------------------------------------------------------------
//w^Oň͂܂ꂽ폜
//---------------------------------------------------------------------------
void del_tag_block(TStringList *lst, AnsiString start_wd, AnsiString end_wd)
{
	bool flag = false;
	int i = 0;
	while (i<lst->Count) {
		AnsiString s = lst->Strings[i];
		if (s.AnsiPos("<")==1) s = s.UpperCase();
		if (!flag) {
			if (s.AnsiPos(start_wd)==1) {
				flag = (s.AnsiPos(end_wd)==0);
				lst->Delete(i);
			} else
				i++;
		} else {
			flag = (s.AnsiPos(end_wd)==0);
			lst->Delete(i);
		}
	}
}


//---------------------------------------------------------------------------
HtmConv::HtmConv()
{
	HtmBuf = new TStringList();
	TxtBuf = new TStringList();

	TempDir 	 = EmptyStr;
	StatMsg		 = EmptyStr;

	LineWidth	 = DEF_LINE_WIDTH;
	ForceCr 	 = false;
	BlankLnLimit = DEF_BLANK_LN_LIMIT;
	NoPstHdr	 = false;
	HrLineStr	 = "-";
	IndentStr	 = "  ";
	UlMarkStr	 = "E";
	ZenNumber	 = false;

	UseAlt		 = false;
	AddImgSrc	 = false;
	DefAltStr	 = "摜";
	AltBraStr	 = "[";
	AltKetStr	 = "]";
	B_BraStr	 = EmptyStr;
	B_KetStr	 = EmptyStr;
	I_BraStr	 = EmptyStr;
	I_KetStr	 = EmptyStr;
	U_BraStr	 = EmptyStr;
	U_KetStr	 = EmptyStr;
	CellSepStr	 = "\t";

	InsLink 	 = false;
	OnlyExLink	 = true;
	AddCrLink	 = false;
	LnkBraStr	 = "<";
	LnkKetStr	 = ">";

	FileName	 = EmptyStr;
	FileTime	 = EmptyStr;

	HeadStr 	 = EmptyStr;
	FootStr 	 = EmptyStr;

	AlignList = new TStringList();

	//̎Q
	EntList = new TStringList();
	EntList->Add("&quot;=\"");
	EntList->Add("&lt;=<");
	EntList->Add("&gt;=>");
	EntList->Add("&nbsp;= ");
	EntList->Add("&#160;= ");
	EntList->Add("&yen;=\\");
	EntList->Add("&#165;=\\");
	EntList->Add("&copy;=(c)");
	EntList->Add("&#169;=(c)");
	EntList->Add("&reg;=(R)");
	EntList->Add("&#174;=(R)");
	EntList->Add("&deg;=");
	EntList->Add("&#176;=");
	EntList->Add("&plusmn;=}");
	EntList->Add("&#177;=}");
	EntList->Add("&ndash;=-");
	EntList->Add("&#8211;=-");
}

//---------------------------------------------------------------------------
HtmConv::~HtmConv()
{
	delete HtmBuf;
	delete TxtBuf;
	delete AlignList;
	delete EntList;
}

//---------------------------------------------------------------------------
AnsiString HtmConv::GetTag(AnsiString s)
{
	AnsiString retstr = EmptyStr;
	if (s.IsEmpty()) return retstr;

	int flag = 0;
	for (int i=1;i<=s.Length();i++) {
		AnsiString c = s.SubString(i,1);
		switch (flag) {
		case 0:
			if (c!="<") flag = -1; else flag = 1;
			break;
		case 1:
			if ((c==">") || (c==" "))
				flag = -1;
			else
				retstr += c.UpperCase();
			break;
		}
		if (flag==-1) break;
	}
	return retstr;
}

//---------------------------------------------------------------------------
//vfw肵̒l擾
AnsiString HtmConv::GetTagAtr(AnsiString s, AnsiString t, AnsiString a)
{
	AnsiString retstr = EmptyStr;
	if (s.IsEmpty()) return retstr;
	int flag = 0;
	AnsiString tag;
	AnsiString atr;
	AnsiString vstr;
	bool qflag;

	for (int i=1;i<=s.Length();i++) {
		AnsiString c = s.SubString(i,1);
		switch (flag) {
		case 0:
			if (c=="<") {
				tag  = EmptyStr;
				flag = 1;
			}
			break;
		case 1:
			if (c==">")
				flag = 0;
			else
			if (c==" ") {	//^Om
				tag = tag.Trim();
				atr  = EmptyStr;
				flag = 2;
			} else
				tag += c;
			break;
		case 2:
			if (c=="=") {	//m
				atr = atr.Trim();
				flag = 3;
			} else
			if (c==">")
				flag = 0;
			else
				atr += c;
			break;
		case 3:
			if (c==">")
				flag = 0;
			else
			if (c!=" ") {	//lJn
				qflag = (c=="\"");
				if (qflag) vstr = EmptyStr; else vstr = c;
				flag = 4;
			}
			break;
		case 4:
			if ((qflag && (c=="\"")) || (!qflag && ((c==" ") || (c==">")))) {
				if ((tag.AnsiCompareIC(t)==0) && (atr.AnsiCompareIC(a)==0)) {
					retstr = vstr;
					flag   = -1;	//lm!
				} else {
					atr = EmptyStr;
					if (c==">") flag = 0; else flag = 2;
				}
			} else
				vstr += c;
			break;
		}

		if (flag==-1) break;
	}

	return retstr;
}

//---------------------------------------------------------------------------
//̎QƂ̉
AnsiString HtmConv::RefEntity(AnsiString s)
{
	if (s.IsEmpty()) return s;

	for (int i=0;i<EntList->Count;i++) {
		AnsiString swd = EntList->Names[i];
		AnsiString rwd = EntList->Values[swd];
		for (;;) {
			int p = s.AnsiPos(swd);  if (p==0) break;
			s.Delete(p, swd.Length());
			s.Insert(rwd, p);
		}
	}
	s = replace_str(s, "&amp;", "&");

	if (s.AnsiPos("&")>0) {
		int stt = 0;
		int p = 1;
		int p0;
		while (p<=s.Length()) {
			if (s[p]=='&') {
				stt = 1;
				p++;
			} else {
				switch (stt) {
				case 1:
					if (s[p]=='#') {
						p0 = p+1;
						stt = 2;
					} else
						stt = 0;
					p++;
					break;
				case 2:
					if (s[p]==';') {
						int cn = s.SubString(p0, p-p0).ToIntDef(0);
						p0 -= 2;
						s.Delete(p0, p-p0+1);
						if ((cn>=32) && (cn<127))
							s.Insert(AnsiString((char)cn), p0);
						else
							s.Insert("?", p0);
						p = p0+1;
						stt = 0;
					} else
						p++;
					break;
				default:
					p++;
				}
			}
		}
	}

	return s;
}

//---------------------------------------------------------------------------
//HTML̃^Cg擾
//  fnam: HTML̃t@C
//---------------------------------------------------------------------------
AnsiString HtmConv::GetTitle(AnsiString fnam)
{
	AnsiString titstr = EmptyStr;

	FILE *fp = fopen(fnam.c_str(), "rt");
	if (fp) {
		AnsiString headstr = EmptyStr;
		char sbuf[2048];
		while (!feof(fp)) {
			fgets(sbuf,2000,fp);
			char *c;
			c = strchr(sbuf,'\r'); if (c!=NULL) *c='\0';
			c = strchr(sbuf,'\n'); if (c!=NULL) *c='\0';
			AnsiString s = sbuf;
			int p = s.AnsiPos("</HEAD>");
			if (p==0) p = s.AnsiPos("</head>");
			if (p>0) {
				s = s.SubString(1,p+6);
				headstr += s;
				break;
			} else
				headstr += s;
		}
		fclose(fp);

		//charset `FbN
		int p = ansi_pos_i("charset", headstr);
		AnsiString charset = EmptyStr;
		if (p>0) {
			AnsiString tmpstr = headstr.SubString(p, headstr.Length()-p+1);
			p = tmpstr.AnsiPos("=");
			if (p) {
				tmpstr.Delete(1, p);
				p = tmpstr.AnsiPos("\"");
				if (p==0) p = tmpstr.AnsiPos(">");
				if (p>0) charset = tmpstr.SubString(1,p-1);
			}
		}

		//R[h Shift-JIS ɕϊ
		if (charset.AnsiCompareIC("EUC-JP")==0)
			headstr = cv_euc_str(headstr);
		else
		if (charset.AnsiCompareIC("ISO-2022-JP")==0)
			headstr = cv_jis_str(headstr);
		else
		if (charset.AnsiCompareIC("UTF-8")==0)
			headstr = cv_utf8_str(headstr);

		//Rg폜
		int p0,p1;
		p0 = headstr.AnsiPos("<!--");
		while (p0>0) {
			p1 = headstr.AnsiPos("-->");
			if (p1>p0) {
				headstr.Delete(p0, p1-p0+3);
				p0 = headstr.AnsiPos("<!--");
			} else {
				headstr = headstr.SubString(1,p1-1);
				break;
			}
		}

		//^Cg擾
		p0 = ansi_pos_i("<TITLE>",  headstr);
		p1 = ansi_pos_i("</TITLE>", headstr);
		if ((p0>0) && (p1>p0)) {
			titstr = RefEntity(headstr.SubString(p0+7, p1-p0-7));
		}
	}

	return titstr;
}

//---------------------------------------------------------------------------
//t@C܂URLHTML\[XǂݍSHIFT-JIS ɕϊ
// fnam: HTMLt@CAV[gJbgt@CAURL
//---------------------------------------------------------------------------
bool HtmConv::LoadFile(AnsiString fnam)
{
	HtmBuf->Clear();
	StatMsg = EmptyStr;
	UrlStr	= EmptyStr;
	BaseStr = EmptyStr;

	if (fnam.AnsiPos("http://")==1) {
		UrlStr = fnam;
	} else
	if (ExtractFileExt(fnam).UpperCase()==".URL") {
		if (FileExists(fnam)) {
			TStringList *tmplst = new TStringList();
			tmplst->LoadFromFile(fnam);
			for (int i=0;i<tmplst->Count;i++) {
				if (tmplst->Strings[i].AnsiPos("URL=")!=1) continue;
				UrlStr = tmplst->Strings[i].Delete(1,4);
				break;
			}
			delete tmplst;
		} else
			return false;
	}

	if (!UrlStr.IsEmpty()) {
		BaseStr = UrlStr;
		if (BaseStr[BaseStr.Length()]!='/') {
			AnsiString tmpstr = BaseStr;
			tmpstr.Delete(1,7);
			if (tmpstr.AnsiPos("/")==0) {
				BaseStr += "/";
			} else {
				int i = BaseStr.Length();
				while (i>7) {
					if (BaseStr[i]=='/') break;
					BaseStr.Delete(i--,1);
				}
			}
		}

		//C^[lbgHTML擾
		DWORD flag;
		if (InternetGetConnectedState(&flag, 0)) {
			AnsiString tmpfil = TempDir+"\\$$~DOWLD.tmp";
			HINTERNET hSession = InternetOpen(
				"H2Tconv", INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
			if (hSession) {
				HINTERNET hConnect = InternetOpenUrl(hSession,
				    UrlStr.c_str(), NULL, 0, INTERNET_FLAG_RELOAD, 0);
				if (hConnect) {
					char ldbuf[1024];
					DWORD dwSize;
		            FILE *fp = fopen(tmpfil.c_str(), "wb");
					for (;;) {
						if (!InternetReadFile(hConnect, &ldbuf, 1024, &dwSize)) break;
				        if (dwSize==0) break;
						fwrite(ldbuf, dwSize, 1, fp);
					}
					fclose(fp);
					InternetCloseHandle(hConnect);
					HtmBuf->LoadFromFile(tmpfil);
					DeleteFile(tmpfil);
				} else
					StatMsg = "wURLJ";
			    InternetCloseHandle(hSession);
			} else
				StatMsg = "ڑł܂";
			FileName = EmptyStr;
			FileTime = DateTimeToStr(Now());
		} else {
			StatMsg = "C^[lbgɐڑĂ܂";
		}
	} else {
	//t@Cǂݍ
		if (FileExists(fnam)) {
			HtmBuf->LoadFromFile(fnam);
			FileName = fnam;
			FileTime = DateTimeToStr(FileDateToDateTime(FileAge(fnam)));
		} else
			return false;
	}

	//SHIFT-JIS ɕϊ
	if (HtmBuf->Count>0) {
		AnsiString tmpbuf = HtmBuf->Text;
		AnsiString chrset = EmptyStr;
		do {
			//wb_o
			int p = ansi_pos_i("<head>", tmpbuf); if (p==0) break;
			tmpbuf = tmpbuf.Delete(1, p+6);
			p = ansi_pos_i("</head>", tmpbuf);
			if (p>0) tmpbuf = tmpbuf.SubString(1,p-1);
			//R[hw肳Ă邩ׂ
			TStringList *tmplst = new TStringList();
			tmplst->Text = tmpbuf;
			for (int i=0;i<tmplst->Count;i++) {
				AnsiString tmpstr = GetTagAtr(tmplst->Strings[i], "META", "http-equiv");
				if (tmpstr.IsEmpty()) continue;
				tmpstr = GetTagAtr(tmplst->Strings[i], "META", "content");
				if ((p = ansi_pos_i("charset", tmpstr)) == 0) continue;;
				tmpstr.Delete(1, p-1);
				if ((p = tmpstr.AnsiPos("=")) == 0) continue;
				chrset = tmpstr.Delete(1,p).Trim();
                break;
			}
			delete tmplst;
		} while (0);

		//wb_ŊR[hȂ玩OŔ
		if (chrset.IsEmpty()) chrset = get_charset(HtmBuf->Text);

		//UTF-8
		if (chrset.AnsiCompareIC("utf-8")==0) {
			//BOM ΍폜
			AnsiString tmpbuf = HtmBuf->Strings[0];
			if (tmpbuf.Length()>=3) {
				if ((tmpbuf[1]=='\xef') && (tmpbuf[2]=='\xbb') && (tmpbuf[3]=='\xbf'))
					HtmBuf->Strings[0] = tmpbuf.Delete(1,3);
			}
			//UTF-8  SHIFT-JIS
			HtmBuf->Text = cv_utf8_str(HtmBuf->Text);
		} else
		//EUC
		if ((chrset.AnsiCompareIC("EUC-JP")==0) || (chrset.AnsiCompareIC("x-euc-jp")==0)) {
			HtmBuf->Text = cv_euc_str(HtmBuf->Text);
		} else
		//JIS
		if (chrset.AnsiCompareIC("ISO-2022-JP")==0) {
			HtmBuf->Text = cv_jis_str(HtmBuf->Text);
		}
		return true;
	} else
		return false;
}

//---------------------------------------------------------------------------
//TxtLineBuf 𐮌` TxtBuf 
void HtmConv::FlushText()
{
	if (TxtLineBuf.IsEmpty()) return;
	if (!Skip) {
		//L̕ϊ
		if (!fXMP) TxtLineBuf = RefEntity(TxtLineBuf);

		//AC
		if (!fPRE && !fXMP && (AlignList->Count>0)) {
			AnsiString a = AlignList->Strings[AlignList->Count-1];
			int len = TxtLineBuf.Length();
			if ((len>0) && (len<LineWidth)) {
				AnsiString s = EmptyStr;
				if (a=="CENTER")
					s = AnsiString::StringOfChar(' ', (LineWidth-len)/2);
				else
				if (a=="RIGHT")
					s = AnsiString::StringOfChar(' ', LineWidth-len);
				TxtLineBuf = s + TxtLineBuf;
			}
		}

		if (fPRE || fXMP)
	 		TxtBuf->Add(TxtLineBuf);
		else
		if (ForceCr) {
			//w茅ŋs
			AnsiString tmpstr = TxtLineBuf;
			while (tmpstr.Length()>LineWidth) {
				int w = LineWidth;
				if (tmpstr.IsLeadByte(w)) w--;
				TxtBuf->Add(tmpstr.SubString(1,w));
		 		tmpstr.Delete(1,w);
			}
			if (!tmpstr.IsEmpty()) {
				AnsiString s = trim_ex(TxtLineBuf);
				if (s.IsEmpty())
					TxtBuf->Add(EmptyStr);
				else
					TxtBuf->Add(tmpstr);
			}
		} else {
			AnsiString s = trim_ex(TxtLineBuf);
			if (s.IsEmpty())
				TxtBuf->Add(EmptyStr);
			else
				TxtBuf->Add(TxtLineBuf);
		}
	}
	TxtLineBuf = EmptyStr;
}

//---------------------------------------------------------------------------
//ϊ
//---------------------------------------------------------------------------
void HtmConv::Convert()
{
	StatMsg = EmptyStr;

	TStringList *TmpBuf = new TStringList();

	//------------------------------
	//^Osɕ
	//------------------------------
	TmpBuf->Clear();
	int i,j,k, n,p;
	for (i=0;i<HtmBuf->Count;i++) {
		AnsiString s = HtmBuf->Strings[i];
		if (!s.IsEmpty()) {
			for (;;) {
				int p0 = s.AnsiPos("<");
				int p1 = s.AnsiPos(">");
				if (p0>1) {
					if (p1>0) {
						if (p0<p1) {
							TmpBuf->Add(s.SubString(1, p0-1));
							s.Delete(1, p0-1);
						} else {
							TmpBuf->Add(s.SubString(1, p1));
							s.Delete(1, p1);
						}
					} else {
						TmpBuf->Add(s.SubString(1, p0-1));
						s.Delete(1, p0-1);
					}
				} else {
					if (p1>0) {
						TmpBuf->Add(s.SubString(1, p1));
						s.Delete(1, p1);
					} else
						break;
				}
			}
			if (!s.IsEmpty()) TmpBuf->Add(s);
		}
		TmpBuf->Add("</>");	//s}[N
	}

	//------------------------------
	//Rg폜
	//------------------------------
	del_tag_block(TmpBuf, "<!--", "-->");

	//------------------------------
	//scriptAsytle 폜
	//RgAEgĂȂꍇ̑΍
	//------------------------------
	del_tag_block(TmpBuf, "<SCRIPT", 	"</SCRIPT>");
	del_tag_block(TmpBuf, "<NOSCRIPT",	"</NOSCRIPT>");
	del_tag_block(TmpBuf, "<STYLE",		"</STYLE>");

	//------------------------------
	//sfĂ^OA
	//------------------------------
	i = 0;
	bool flag = false;
	while (i<TmpBuf->Count) {
		AnsiString s = TmpBuf->Strings[i];
		if (!flag) {
			if (!s.IsEmpty()) flag = ((s[1]=='<') && (s[s.Length()]!='>'));
			i++;
		} else {
			if (s=="</>")
				TmpBuf->Delete(i);
			else {
				if (!s.IsEmpty()) {
					if (s[s.Length()]=='>') flag = false;
				}
				TmpBuf->Strings[i-1] = TmpBuf->Strings[i-1] + " " + TmpBuf->Strings[i];
				TmpBuf->Delete(i);
			}
		}
	}

	//------------------------------
	//]ȔpXy[X폜
	//------------------------------
	fPRE = fXMP = false;
	i = 0;
	while (i<TmpBuf->Count) {
		AnsiString s = TmpBuf->Strings[i];
		AnsiString tag = GetTag(s);
		if (fPRE) {
			if (tag=="/PRE") fPRE = false;
			i++;
		}else
		if (fXMP) {
			if (tag=="/XMP") fXMP = false;
			i++;
		} else
		if (!tag.IsEmpty()) {
			if (tag=="PRE")  fPRE = true; else
			if (tag=="XMP")  fXMP = true;
			TmpBuf->Strings[i++] = s.Trim();
		} else {
			//ApXy[X
			s = s.Trim();
			while ((p=s.AnsiPos("  ")) > 0) s.Delete(p,1);
			if (s.IsEmpty())
				TmpBuf->Delete(i);
			else
				TmpBuf->Strings[i++] = s;
		}
	}

	//------------------------------
	//ϊ
	//------------------------------
	AlignList->Clear();
	int  DL_level = 0;
	int  LI_level = 0;
	int  LI_No[100];
	char OL_type[100];
	int  fTR    = 0;
	int  fTITLE = 0;
	int  fP_al  = 0;
	int  fTABLE = 0;
	bool pstHdr = false;
	fPRE = fXMP = false;
	Skip = false;

	TxtLineBuf = EmptyStr;
	TitleStr   = EmptyStr;
	AnsiString tmpstr, HrefStr;
	AnsiString DescrStr = EmptyStr;
	AnsiString KeywdStr = EmptyStr;

	int topline = TxtBuf->Count;

	AnsiString BrkTag
		= "|H1|H2|H3|H4|H5|H6|P|HR|DIV|CENTER|BLOCKQUOTE|TABLE|TR|TH|TD|UL|OL|DL|LI|PRE|XMP|";

	for (i=0;i<TmpBuf->Count;i++) {
		AnsiString lbuf = TmpBuf->Strings[i];
		AnsiString tag	= GetTag(lbuf);
		if (tag.IsEmpty()) {
			pstHdr = false;
			if (fTITLE)
				TitleStr += lbuf;
			else if (fPRE || fXMP)
				TxtLineBuf += lbuf;
			else if (!Skip) {
				//pԂɃXy[X}
				do {
					if (TxtLineBuf.IsEmpty() || lbuf.IsEmpty()) break;
					if (StrByteType(TxtLineBuf.c_str(), TxtLineBuf.Length()-1) != mbSingleByte) break;
					if (StrByteType(lbuf.c_str(), 0) != mbSingleByte) break;
					if (TxtLineBuf[TxtLineBuf.Length()]==' ') break;
					if (lbuf[1]==' ') break;
					TxtLineBuf += " ";
				} while (0);
				TxtLineBuf += lbuf;
			}
		} else {
			if ((fP_al>0) && (BrkTag.AnsiPos("|"+tag+"|")>0)) {
				//<P> u[Nꂽ
				FlushText();
				if (AlignList->Count>0) AlignList->Delete(AlignList->Count-1);
				fP_al--;
			}

			if (tag=="/") {
				if (fPRE || fXMP) {
					AnsiString s = trim_ex(TxtLineBuf);
					if (s.IsEmpty())
				 		TxtBuf->Add(TxtLineBuf);
					else
						FlushText();
				}
			} else

			if (tag=="/XMP") {
				FlushText();	fXMP = false;
			} else
			if (fXMP) {
				TxtLineBuf += lbuf;
			} else

			if (tag=="B") TxtLineBuf += B_BraStr;
			else if (tag=="/B") TxtLineBuf += B_KetStr;
			else if (tag=="I")  TxtLineBuf += I_BraStr;
			else if (tag=="/I") TxtLineBuf += I_KetStr;
			else if (tag=="U")  TxtLineBuf += U_BraStr;
			else if (tag=="/U") TxtLineBuf += U_KetStr;
			else

			if (tag=="P") {
				FlushText();
				if (!pstHdr) TxtBuf->Add(EmptyStr);
				pstHdr = false;
				if (fTABLE==0) {
					tmpstr = GetTagAtr(lbuf, tag, "ALIGN").UpperCase();
					if (tmpstr.IsEmpty() && (AlignList->Count>0))
						tmpstr = AlignList->Strings[AlignList->Count-1];
					AlignList->Add(tmpstr);
				} else
					AlignList->Add(EmptyStr);
				fP_al++;
			} else
			if (tag=="/P") {
				FlushText();
				if (fP_al>0) {
					if (AlignList->Count>0) AlignList->Delete(AlignList->Count-1);
					fP_al--;
				}
			} else
			if (tag=="BR") {
				if (!TxtLineBuf.IsEmpty()) FlushText(); else TxtBuf->Add(EmptyStr);
				n = LI_level + DL_level;
				for (j=0;j<n;j++) TxtLineBuf += IndentStr;
			} else
			if (tag=="PRE") {
				FlushText();	fPRE = true;
			} else
			if (tag=="/PRE") {
				FlushText();	fPRE = false;
			} else
			if (tag=="XMP") {
				FlushText();	fXMP = true;
			} else

			if (tag=="CENTER") {
				FlushText();
				AlignList->Add("CENTER");
			} else
			if (tag=="/CENTER") {
				FlushText();
				if (AlignList->Count>0) AlignList->Delete(AlignList->Count-1);
			} else
			if (tag=="DIV") {
				FlushText();
				AlignList->Add(GetTagAtr(lbuf, tag, "ALIGN").UpperCase());
			} else
			if (tag=="/DIV") {
				FlushText();
				if (AlignList->Count>0) AlignList->Delete(AlignList->Count-1);
			} else

			if ((n=AnsiString("|H1|H2|H3|H4|H5|H6|").AnsiPos("|"+tag+"|")) > 0) {
				FlushText();
				if (!pstHdr && (TxtBuf->Count>0)) TxtBuf->Add(EmptyStr);
				pstHdr = false;
				n = (n-1)/3;
				TxtLineBuf = HeaderStr[n];
			} else
			if (AnsiString("|/H1|/H2|/H3|/H4|/H5|/H6|").AnsiPos("|"+tag+"|") > 0) {
				FlushText();
				if (NoPstHdr) pstHdr = true;
			} else

			if (tag=="HR") {
				FlushText();
				if (!HrLineStr.IsEmpty()) {
					tmpstr = GetTagAtr(lbuf, tag, "WIDTH").UpperCase();
					n = std::max(LineWidth/HrLineStr.Length(), 1);
					if (!tmpstr.IsEmpty()) {
						if (tmpstr[tmpstr.Length()]=='%') {
							tmpstr.Delete(tmpstr.Length(),1);
							n = std::min(tmpstr.ToIntDef(100), 100);
							n = std::max((LineWidth/HrLineStr.Length())*n/100, 1);
							tmpstr = GetTagAtr(lbuf, tag, "ALIGN").UpperCase();
							if (tmpstr.IsEmpty()) tmpstr = "CENTER";
							AlignList->Add(tmpstr);
							for (j=0;j<n;j++) TxtLineBuf += HrLineStr;
							FlushText();
							AlignList->Delete(AlignList->Count-1);
						} else {
							for (j=0;j<n;j++) TxtLineBuf += HrLineStr;
							FlushText();
						}
					} else {
						for (j=0;j<n;j++) TxtLineBuf += HrLineStr;
						FlushText();
					}
				}
			} else

			if (tag=="UL") {
				FlushText();
				if ((LI_level==0) && (!pstHdr)) TxtBuf->Add(EmptyStr);
				pstHdr = false;
				LI_No[++LI_level] = -1;
			} else
			if (tag=="OL") {
				FlushText();
				if ((LI_level==0) && (!pstHdr)) TxtBuf->Add(EmptyStr);
				pstHdr = false;
				LI_No[++LI_level] = GetTagAtr(lbuf, tag, "START").ToIntDef(1);
				tmpstr = GetTagAtr(lbuf, tag, "TYPE");
				if (tmpstr.IsEmpty())
					OL_type[LI_level] = '1';
				else
					OL_type[LI_level] = tmpstr[1];

			} else
			if ((tag=="/UL") || (tag=="/OL")) {
				FlushText();
				LI_level = std::max(LI_level-1, 0);
			} else
			if (tag=="LI") {
				FlushText();
				if (LI_level>0) {
					//tXg
					n = LI_level + DL_level;
					for (j=0;j<n;j++) TxtLineBuf += IndentStr;
					if (LI_No[LI_level]>0) {
						n = LI_No[LI_level];
						switch (OL_type[LI_level]) {
						case '1': tmpstr = IntToStr(n); 				break;
						case 'a': tmpstr = int_to_alpha(n); 			break;
						case 'A': tmpstr = int_to_alpha(n).UpperCase(); break;
						case 'i': tmpstr = int_to_roman(n); 			break;
						case 'I': tmpstr = int_to_roman(n).UpperCase(); break;
						}
						tmpstr += ".";
						if (ZenNumber) tmpstr = to_zenstr(tmpstr);
						TxtLineBuf += tmpstr;
						LI_No[LI_level]++;
					} else
						//Xg
						TxtLineBuf += UlMarkStr;
				}
			} else

			if (tag=="DL") {
				FlushText();
				if ((DL_level==0) && (!pstHdr)) TxtBuf->Add(EmptyStr);
				pstHdr = false;
				DL_level++;
			} else
			if (tag=="/DL") {
				FlushText();
				DL_level = std::max(DL_level-1, 0);
			} else
			if (tag=="DT") {
				FlushText();
				if (DL_level>0) {
					n = LI_level + DL_level-1;
					for (j=0;j<n;j++) TxtLineBuf += IndentStr;
				}
			} else
			if (tag=="DD") {
				if (DL_level>0) {
					FlushText();
					n = LI_level + DL_level;
					for (j=0;j<n;j++) TxtLineBuf += IndentStr;
				}
			} else

			if (tag=="TABLE") {
				FlushText();
				if (!pstHdr) TxtBuf->Add(EmptyStr);
				pstHdr = false;
				AlignList->Add(EmptyStr);
				fTABLE++;
			} else
			if (tag=="/TABLE") {
				FlushText();
				if (AlignList->Count>0) AlignList->Delete(AlignList->Count-1);
				fTABLE--;
			} else

			if (AnsiString("|CAPTION|/TR|/CAPTION|").AnsiPos("|"+tag+"|")>0) {
				FlushText();
			} else

			if ((tag=="TD") || (tag=="TH")) {
				if (fTR>0)
					fTR = 0;
				else
					if (!TxtLineBuf.IsEmpty()) TxtLineBuf += CellSepStr;
			} else
			if (tag=="TR") {
				FlushText();
				fTR = 1;
			} else

			if ((tag=="A") && InsLink) {
				HrefStr = GetTagAtr(lbuf, tag, "HREF");
				if (OnlyExLink) {
					if ((HrefStr.AnsiPos("http:")!=1) && (HrefStr.AnsiPos("mailto:")!=1))
						HrefStr = EmptyStr;
				}
				//\ȂΎw
				do {
					if (HrefStr.IsEmpty()) break;
					if (HrefStr.AnsiPos("file:")==1) break;
					if (HrefStr.AnsiPos("http:")==1) break;
					if (HrefStr.AnsiPos("mailto:")==1) break;
					if (BaseStr.IsEmpty()) break;
					HrefStr = BaseStr + HrefStr;
				} while (0);
			} else
			if ((tag=="/A") && InsLink) {
				if (!HrefStr.IsEmpty()) {
					tmpstr = LnkBraStr + HrefStr + LnkKetStr;
					if (AddCrLink) tmpstr = "\r\n" + tmpstr + "\r\n";
					TxtLineBuf += tmpstr;
				}
				HrefStr = EmptyStr;
			} else

			if ((tag=="IMG") && (UseAlt || AddImgSrc)) {
				TxtLineBuf += AltBraStr;
				if (UseAlt) {
					tmpstr = GetTagAtr(lbuf, tag, "ALT");
					if (tmpstr.IsEmpty()) tmpstr = DefAltStr;
					TxtLineBuf += tmpstr;
				}
				if (AddImgSrc) {
					tmpstr = GetTagAtr(lbuf, tag, "SRC");
					if (!tmpstr.IsEmpty()) {
						//\ȂΎw
						do {
							if (tmpstr.AnsiPos("file:")==1) break;
							if (tmpstr.AnsiPos("http:")==1) break;
							if (BaseStr.IsEmpty()) break;
							tmpstr = BaseStr + tmpstr;
						} while (0);
						if (UseAlt) TxtLineBuf += " ";
						TxtLineBuf += tmpstr;
					}
				}
				TxtLineBuf += AltKetStr;
			} else

			if (tag=="HEAD")
				Skip = true;
			else if ((tag=="/HEAD") || (tag=="BODY")) {
				Skip   = false;
				fTITLE = 0;
			} else
			if (tag=="TITLE")
				fTITLE ++;
			else if (tag=="/TITLE")
				fTITLE = 0;
			else if (tag=="BASE") {
				tmpstr = GetTagAtr(lbuf, tag, "HREF");
				if (!tmpstr.IsEmpty()) {
					if (tmpstr[tmpstr.Length()]!='/') tmpstr += "/";
					BaseStr = tmpstr;
				}
			} else

			if (tag=="META") {
				tmpstr = GetTagAtr(lbuf, tag, "NAME");
				if (!tmpstr.IsEmpty()) {
					if (tmpstr.AnsiCompareIC("description")==0)
						DescrStr = GetTagAtr(lbuf, tag, "CONTENT");
					else
					if (tmpstr.AnsiCompareIC("keywords")==0)
						KeywdStr = GetTagAtr(lbuf, tag, "CONTENT");
				}
			}
		}
	}
	FlushText();

	TitleStr = RefEntity(TitleStr);

	//As̐
	i = topline;
	int blkln = 0;
	while (i<TxtBuf->Count) {
		if (TxtBuf->Strings[i].IsEmpty()) {
			blkln++;
			if (blkln>BlankLnLimit) TxtBuf->Delete(i); else i++;
		} else {
			blkln = 0;
			i++;
		}
	}

	//wb_Etb^̑}
	TmpBuf->Clear();
	for (int lopn = 0;lopn<2;lopn++) {
		if (lopn==0)
			TmpBuf->Text = HeadStr;
		else
			TmpBuf->Text = FootStr;
		if (TmpBuf->Count==0) continue;

		for (i=0;i<TmpBuf->Count;i++) {
			//̓WJ
			AnsiString s = TmpBuf->Strings[i];
			for (int j=0;j<9;j++) {
				AnsiString swd,rwd;
				switch (j) {
				case  0: swd = "$TITLE"; rwd = TitleStr;				  break;
				case  1: swd = "$DTIME"; rwd = DateTimeToStr(Now());	  break;
				case  2:
					swd = "$FNAME";
					if (!UrlStr.IsEmpty())
						rwd = UrlStr;
					else
						rwd = ExtractFileName(FileName);
					break;
				case  3:
					swd = "$FTIME"; rwd = FileTime;	break;
				case  4:
					swd = "$LINE1";
					rwd = AnsiString::StringOfChar('-', LineWidth);
					break;
				case  5:
					swd = "$LINE2";
					rwd = EmptyStr;
					for (k=0;k<LineWidth/2;k++) rwd += "";
					break;
				case  6:
					swd = "$LINE3";
					rwd = EmptyStr;
					for (k=0;k<LineWidth/2;k++) rwd += "";
					break;
				case  7:
					swd = "$DESCR"; rwd = DescrStr; break;
				case  8:
					swd = "$KEYWD"; rwd = KeywdStr; break;
				}
				s = replace_str(s, swd, rwd);
			}
			//eLXgɑ}
			if (lopn==0)
				TxtBuf->Insert(topline+i, s);	//wb_
			else
				TxtBuf->Add(s);	//tb^
		}
	}

	delete TmpBuf;
}
//---------------------------------------------------------------------------
